import { AnonymousSubject } from 'rxjs/internal/Subject'; // tslint:disable-line rxjs-no-compat no-submodule-imports rxjs-no-internal
export class DataChannelSubject extends AnonymousSubject {
    constructor(createDataChannelObserver, createTransportObservable, dataChannel, subjectConfig) {
        const observable = createTransportObservable(dataChannel, subjectConfig);
        const observer = createDataChannelObserver(dataChannel);
        super(observer, observable);
        this._dataChannel = dataChannel;
    }
    close() {
        this._dataChannel.close();
    }
    send(message) {
        const { destination } = this;
        if (!this.isStopped) {
            return destination.send(message);
        }
        return Promise.resolve();
    }
}
//# sourceMappingURL=data-channel-subject.js.map