import { AnonymousSubject } from 'rxjs/internal/Subject'; // tslint:disable-line rxjs-no-compat no-submodule-imports rxjs-no-internal
import { filter, map } from 'rxjs/operators';
export class MaskedSubject extends AnonymousSubject {
    // tslint:disable-next-line max-line-length rxjs-no-exposed-subjects
    constructor(getTypedKeys, mask, maskableSubject) {
        const destination = {
            complete: maskableSubject.complete,
            error: maskableSubject.error,
            next: (value) => this.send(value)
        };
        const stringifiedValues = getTypedKeys(mask).map((key) => [key, JSON.stringify(mask[key])]);
        const source = maskableSubject.pipe(filter((message) => stringifiedValues.every(([key, value]) => value === JSON.stringify(message[key]))), map(({ message }) => message));
        super(destination, source);
        this._mask = mask;
        this._maskableSubject = maskableSubject;
    }
    close() {
        this._maskableSubject.close();
    }
    send(value) {
        return this._maskableSubject.send({ ...this._mask, message: value });
    }
}
//# sourceMappingURL=masked-subject.js.map