import { AnonymousSubject } from 'rxjs/internal/Subject'; // tslint:disable-line rxjs-no-compat no-submodule-imports rxjs-no-internal
export class WebSocketSubject extends AnonymousSubject {
    constructor(createTransportObservable, createWebSocketObserver, webSocket, subjectConfig) {
        const observable = createTransportObservable(webSocket, subjectConfig);
        const observer = createWebSocketObserver(webSocket);
        super(observer, observable);
        this._webSocket = webSocket;
    }
    close() {
        this._webSocket.close();
    }
    send(message) {
        const { destination } = this;
        if (!this.isStopped) {
            return destination.send(message);
        }
        return Promise.resolve();
    }
}
//# sourceMappingURL=web-socket-subject.js.map