(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/classCallCheck'), require('@babel/runtime/helpers/createClass'), require('@babel/runtime/helpers/possibleConstructorReturn'), require('@babel/runtime/helpers/getPrototypeOf'), require('@babel/runtime/helpers/inherits'), require('rxjs/internal/Subject'), require('@babel/runtime/helpers/defineProperty'), require('@babel/runtime/helpers/slicedToArray'), require('rxjs/operators'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/classCallCheck', '@babel/runtime/helpers/createClass', '@babel/runtime/helpers/possibleConstructorReturn', '@babel/runtime/helpers/getPrototypeOf', '@babel/runtime/helpers/inherits', 'rxjs/internal/Subject', '@babel/runtime/helpers/defineProperty', '@babel/runtime/helpers/slicedToArray', 'rxjs/operators', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.rxjsBroker = {}, global._classCallCheck, global._createClass, global._possibleConstructorReturn, global._getPrototypeOf, global._inherits, global.Subject, global._defineProperty, global._slicedToArray, global.operators, global.rxjs));
})(this, (function (exports, _classCallCheck, _createClass, _possibleConstructorReturn, _getPrototypeOf, _inherits, Subject, _defineProperty, _slicedToArray, operators, rxjs) { 'use strict';

    var BUFFERED_AMOUNT_LOW_THRESHOLD = 2048;
    var DataChannelObserver = /*#__PURE__*/function () {
      function DataChannelObserver(dataChannel) {
        _classCallCheck(this, DataChannelObserver);
        this._dataChannel = dataChannel;
        if (typeof dataChannel.bufferedAmountLowThreshold === 'number') {
          this._isSupportingBufferedAmountLowThreshold = true;
          if (dataChannel.bufferedAmountLowThreshold === 0) {
            dataChannel.bufferedAmountLowThreshold = BUFFERED_AMOUNT_LOW_THRESHOLD;
          }
        } else {
          this._isSupportingBufferedAmountLowThreshold = false;
        }
      }
      return _createClass(DataChannelObserver, [{
        key: "complete",
        value: function complete() {
          // This method does nothing because the DataChannel can be closed separately.
        }
      }, {
        key: "error",
        value: function error(err) {
          throw err;
        }
      }, {
        key: "next",
        value: function next(value) {
          this.send(value);
        }
      }, {
        key: "send",
        value: function send(message) {
          var _this = this;
          if (this._dataChannel.readyState === 'open') {
            if (this._isSupportingBufferedAmountLowThreshold && this._dataChannel.bufferedAmount > this._dataChannel.bufferedAmountLowThreshold) {
              return new Promise(function (resolve, reject) {
                var _handleBufferedAmountLowEvent = function handleBufferedAmountLowEvent() {
                  _this._dataChannel.removeEventListener('bufferedamountlow', _handleBufferedAmountLowEvent);
                  _this._dataChannel.removeEventListener('error', _handleErrorEvent); // tslint:disable-line:no-use-before-declare
                  _this.send(message);
                  resolve();
                };
                var _handleErrorEvent = function handleErrorEvent(_ref) {
                  var error = _ref.error;
                  _this._dataChannel.removeEventListener('bufferedamountlow', _handleBufferedAmountLowEvent);
                  _this._dataChannel.removeEventListener('error', _handleErrorEvent);
                  reject(error);
                };
                _this._dataChannel.addEventListener('bufferedamountlow', _handleBufferedAmountLowEvent);
                _this._dataChannel.addEventListener('error', _handleErrorEvent);
              });
            }
            return Promise.resolve(this._dataChannel.send(JSON.stringify(message)));
          }
          return new Promise(function (resolve, reject) {
            var _handleErrorEvent2 = function handleErrorEvent(_ref2) {
              var error = _ref2.error;
              _this._dataChannel.removeEventListener('error', _handleErrorEvent2);
              _this._dataChannel.removeEventListener('open', _handleOpenEvent); // tslint:disable-line:no-use-before-declare
              reject(error);
            };
            var _handleOpenEvent = function handleOpenEvent() {
              _this._dataChannel.removeEventListener('error', _handleErrorEvent2);
              _this._dataChannel.removeEventListener('open', _handleOpenEvent);
              resolve(_this.send(message));
            };
            _this._dataChannel.addEventListener('error', _handleErrorEvent2);
            _this._dataChannel.addEventListener('open', _handleOpenEvent);
          });
        }
      }]);
    }();

    var createDataChannelObserver = function createDataChannelObserver(dataChannel) {
      return new DataChannelObserver(dataChannel);
    };

    function _callSuper$3(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct$3() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
    function _isNativeReflectConstruct$3() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$3 = function _isNativeReflectConstruct() { return !!t; })(); }
    var DataChannelSubject = /*#__PURE__*/function (_AnonymousSubject) {
      function DataChannelSubject(createDataChannelObserver, createTransportObservable, dataChannel, subjectConfig) {
        var _this;
        _classCallCheck(this, DataChannelSubject);
        var observable = createTransportObservable(dataChannel, subjectConfig);
        var observer = createDataChannelObserver(dataChannel);
        _this = _callSuper$3(this, DataChannelSubject, [observer, observable]);
        _this._dataChannel = dataChannel;
        return _this;
      }
      _inherits(DataChannelSubject, _AnonymousSubject);
      return _createClass(DataChannelSubject, [{
        key: "close",
        value: function close() {
          this._dataChannel.close();
        }
      }, {
        key: "send",
        value: function send(message) {
          var destination = this.destination;
          if (!this.isStopped) {
            return destination.send(message);
          }
          return Promise.resolve();
        }
      }]);
    }(Subject.AnonymousSubject);

    var createDataChannelSubjectFactory = function createDataChannelSubjectFactory(createDataChannelObserver, createTransportObservable) {
      return function (dataChannel, subjectConfig) {
        return new DataChannelSubject(createDataChannelObserver, createTransportObservable, dataChannel, subjectConfig);
      };
    };

    function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
    function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), true).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
    function _callSuper$2(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct$2() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
    function _isNativeReflectConstruct$2() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$2 = function _isNativeReflectConstruct() { return !!t; })(); }
    var MaskedSubject = /*#__PURE__*/function (_AnonymousSubject) {
      // tslint:disable-next-line max-line-length rxjs-no-exposed-subjects
      function MaskedSubject(getTypedKeys, mask, maskableSubject) {
        var _this;
        _classCallCheck(this, MaskedSubject);
        var destination = {
          complete: maskableSubject.complete,
          error: maskableSubject.error,
          next: function next(value) {
            return _this.send(value);
          }
        };
        var stringifiedValues = getTypedKeys(mask).map(function (key) {
          return [key, JSON.stringify(mask[key])];
        });
        var source = maskableSubject.pipe(operators.filter(function (message) {
          return stringifiedValues.every(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
              key = _ref2[0],
              value = _ref2[1];
            return value === JSON.stringify(message[key]);
          });
        }), operators.map(function (_ref3) {
          var message = _ref3.message;
          return message;
        }));
        _this = _callSuper$2(this, MaskedSubject, [destination, source]);
        _this._mask = mask;
        _this._maskableSubject = maskableSubject;
        return _this;
      }
      _inherits(MaskedSubject, _AnonymousSubject);
      return _createClass(MaskedSubject, [{
        key: "close",
        value: function close() {
          this._maskableSubject.close();
        }
      }, {
        key: "send",
        value: function send(value) {
          return this._maskableSubject.send(_objectSpread(_objectSpread({}, this._mask), {}, {
            message: value
          }));
        }
      }]);
    }(Subject.AnonymousSubject);

    var createMaskedSubjectFactory = function createMaskedSubjectFactory(getTypedKeys) {
      return function (
      // tslint:disable-line max-line-length
      mask, maskableSubject) {
        return new MaskedSubject(getTypedKeys, mask, maskableSubject);
      };
    };

    function _callSuper$1(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct$1() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
    function _isNativeReflectConstruct$1() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct$1 = function _isNativeReflectConstruct() { return !!t; })(); }
    var defaultDeserializer = function defaultDeserializer(_ref) {
      var data = _ref.data;
      try {
        return JSON.parse(data);
      } catch (_unused) {
        return data;
      }
    };
    // tslint:disable-next-line rxjs-no-subclass
    var TransportObservable = /*#__PURE__*/function (_Observable) {
      function TransportObservable(transport, _ref2) {
        var _ref2$deserializer = _ref2.deserializer,
          deserializer = _ref2$deserializer === void 0 ? defaultDeserializer : _ref2$deserializer,
          openObserver = _ref2.openObserver;
        _classCallCheck(this, TransportObservable);
        return _callSuper$1(this, TransportObservable, [function (observer) {
          var handleCloseEvent = function handleCloseEvent() {
            return observer.complete();
          };
          var handleErrorEvent = function handleErrorEvent(_ref3) {
            var error = _ref3.error;
            return error === undefined ? observer.error(new Error('Unknown Error')) : observer.error(error);
          };
          var handleMessageEvent = function handleMessageEvent(event) {
            return observer.next(deserializer(event));
          };
          var handleOpenEvent = function handleOpenEvent() {
            if (openObserver !== undefined) {
              openObserver.next();
            }
          };
          transport.addEventListener('close', handleCloseEvent);
          transport.addEventListener('error', handleErrorEvent);
          transport.addEventListener('message', handleMessageEvent);
          transport.addEventListener('open', handleOpenEvent);
          return function () {
            transport.removeEventListener('close', handleCloseEvent);
            transport.removeEventListener('error', handleErrorEvent);
            transport.removeEventListener('message', handleMessageEvent);
            transport.removeEventListener('open', handleOpenEvent);
          };
        }]);
      }
      _inherits(TransportObservable, _Observable);
      return _createClass(TransportObservable);
    }(rxjs.Observable);

    var createTransportObservable = function createTransportObservable(transport, subjectConfig) {
      return new TransportObservable(transport, subjectConfig);
    };

    var WebSocketObserver = /*#__PURE__*/function () {
      function WebSocketObserver(webSocket) {
        _classCallCheck(this, WebSocketObserver);
        this._webSocket = webSocket;
      }
      return _createClass(WebSocketObserver, [{
        key: "complete",
        value: function complete() {
          // This method does nothing because the DataChannel can be closed separately.
        }
      }, {
        key: "error",
        value: function error(err) {
          throw err;
        }
      }, {
        key: "next",
        value: function next(value) {
          this.send(value);
        }
      }, {
        key: "send",
        value: function send(message) {
          var _this = this;
          var stringifiedMessage = JSON.stringify(message);
          if (this._webSocket.readyState === WebSocket.OPEN) {
            this._webSocket.send(stringifiedMessage);
            return Promise.resolve();
          }
          if (this._webSocket.readyState === WebSocket.CLOSING) {
            return Promise.reject(new Error('The WebSocket is already closing.'));
          }
          if (this._webSocket.readyState === WebSocket.CLOSED) {
            return Promise.reject(new Error('The WebSocket is already closed.'));
          }
          return new Promise(function (resolve, reject) {
            var _handleErrorEvent = function handleErrorEvent() {
              _this._webSocket.removeEventListener('error', _handleErrorEvent);
              _this._webSocket.removeEventListener('open', _handleOpenEvent); // tslint:disable-line:no-use-before-declare
              reject(new Error('Unknown WebSocket Error'));
            };
            var _handleOpenEvent = function handleOpenEvent() {
              _this._webSocket.removeEventListener('error', _handleErrorEvent);
              _this._webSocket.removeEventListener('open', _handleOpenEvent);
              _this._webSocket.send(stringifiedMessage);
              resolve();
            };
            _this._webSocket.addEventListener('error', _handleErrorEvent);
            _this._webSocket.addEventListener('open', _handleOpenEvent);
          });
        }
      }]);
    }();

    var createWebSocketObserver = function createWebSocketObserver(webSocket) {
      return new WebSocketObserver(webSocket);
    };

    function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
    function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
    var WebSocketSubject = /*#__PURE__*/function (_AnonymousSubject) {
      function WebSocketSubject(createTransportObservable, createWebSocketObserver, webSocket, subjectConfig) {
        var _this;
        _classCallCheck(this, WebSocketSubject);
        var observable = createTransportObservable(webSocket, subjectConfig);
        var observer = createWebSocketObserver(webSocket);
        _this = _callSuper(this, WebSocketSubject, [observer, observable]);
        _this._webSocket = webSocket;
        return _this;
      }
      _inherits(WebSocketSubject, _AnonymousSubject);
      return _createClass(WebSocketSubject, [{
        key: "close",
        value: function close() {
          this._webSocket.close();
        }
      }, {
        key: "send",
        value: function send(message) {
          var destination = this.destination;
          if (!this.isStopped) {
            return destination.send(message);
          }
          return Promise.resolve();
        }
      }]);
    }(Subject.AnonymousSubject);

    var createWebSocketSubjectFactory = function createWebSocketSubjectFactory(createTransportObservable, createWebSocketObserver) {
      return function (webSocket, subjectConfig) {
        return new WebSocketSubject(createTransportObservable, createWebSocketObserver, webSocket, subjectConfig);
      };
    };

    var getTypedKeys = function getTypedKeys(object) {
      return Object.keys(object);
    };

    var createDataChannelSubject = createDataChannelSubjectFactory(createDataChannelObserver, createTransportObservable);
    var createWebSocketSubject = createWebSocketSubjectFactory(createTransportObservable, createWebSocketObserver);
    var connect = function connect(url) {
      var subjectConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return createWebSocketSubject(new WebSocket(url), subjectConfig);
    };
    /**
     * This property is true if the browser supports WebSockets.
     */
    var isSupported = typeof window !== 'undefined' && 'WebSocket' in window;
    var mask = createMaskedSubjectFactory(getTypedKeys);
    var wrap = function wrap(dataChannel) {
      var subjectConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return createDataChannelSubject(dataChannel, subjectConfig);
    };

    exports.connect = connect;
    exports.isSupported = isSupported;
    exports.mask = mask;
    exports.wrap = wrap;

}));
